import { Injectable } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { DefaultParams } from '../../domain/types/default-params.type';
import { IProvideParams } from '../../domain/interfaces/param-provider.interface';

@Injectable()
export class DefaultParamsProvider implements IProvideParams {
  constructor(private readonly configService: ConfigService) {}
  getParams = (): DefaultParams => {
    return {
      MON_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      TUE_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      WED_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      THU_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      FRI_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      SAT_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      SUN_MARGIN: this.configService.get('DEPARTURE_MARGIN'),
      DRIVER: this.configService.get('ROLE') == 'driver' ? true : false,
      SEATS_PROVIDED: this.configService.get('SEATS_PROVIDED'),
      PASSENGER: this.configService.get('ROLE') == 'passenger' ? true : false,
      SEATS_REQUESTED: this.configService.get('SEATS_REQUESTED'),
      STRICT: false,
    };
  };
}
