import { AutoMap } from '@automapper/classes';
import { IsInt, IsUUID } from 'class-validator';

export class Address {
  @IsUUID(4)
  @AutoMap()
  uuid: string;

  @IsUUID(4)
  @AutoMap()
  adUuid: string;

  @IsInt()
  @AutoMap()
  position: number;

  @AutoMap()
  lon: number;

  @AutoMap()
  lat: number;

  @AutoMap()
  name?: string;

  @AutoMap()
  houseNumber?: string;

  @AutoMap()
  street?: string;

  @AutoMap()
  locality: string;

  @AutoMap()
  postalCode: string;

  @AutoMap()
  country: string;
}
