import { hasProperDriverSeats } from '../../domain/dtos/utils/has-driver-seats.validator';

describe('driver and/or driver seats validator', () => {
  it('should validate if driver and drivers seats is not provided ', () => {
    expect(
      hasProperDriverSeats(undefined, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: {},
        property: '',
      }),
    ).toBe(true);
    expect(
      hasProperDriverSeats(false, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: {},
        property: '',
      }),
    ).toBe(true);
    expect(
      hasProperDriverSeats(null, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: {},
        property: '',
      }),
    ).toBe(true);
  });
  it('should not validate if driver is set to true but not the related seats is not provided or 0', () => {
    expect(
      hasProperDriverSeats(true, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: {},
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats(true, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: 0 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats(true, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: undefined },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats(true, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: null },
        property: '',
      }),
    ).toBe(false);
  });
  it('should not validate if driver seats are provided but driver is not set or set to false ', () => {
    expect(
      hasProperDriverSeats(false, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats(undefined, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
    expect(
      hasProperDriverSeats(null, {
        value: undefined,
        constraints: [],
        targetName: '',
        object: { seatsDriver: 1 },
        property: '',
      }),
    ).toBe(false);
  });
});
