import { ArgumentMetadata } from '@nestjs/common';
import { RpcValidationPipe } from '../../pipes/rpc.validation-pipe';
import { FindAdByUuidRequest } from '../../../modules/ad/domain/dtos/find-ad-by-uuid.request';

describe('RpcValidationPipe', () => {
  it('should not validate request', async () => {
    const target: RpcValidationPipe = new RpcValidationPipe({
      whitelist: true,
      forbidUnknownValues: false,
    });
    const metadata: ArgumentMetadata = {
      type: 'body',
      metatype: FindAdByUuidRequest,
      data: '',
    };
    await target.transform(<FindAdByUuidRequest>{}, metadata).catch((err) => {
      expect(err.message).toEqual('Rpc Exception');
    });
  });
});
